;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-beginner-reader.ss" "lang")((modname Hausi3_311017) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #f #t none #f () #f)))
;AUFGABE 1 


(require 2htdp/image)

(define TILE-HEIGHT 20);legt die Höhe (und Breite) der Quadrate des Schachfelds fest
(define C1 "black"); Abkürzung für die Farbe schwarz, die eine Farbe der Quadrate
(define C2 "white"); Abkürzung für die Farbe weiss, die andere Farbe der Quadrate
(define (tile a) (square TILE-HEIGHT "solid" a)); Definition für ein Quadrat des Spielfelds. Der Parameter a legt seine Farbe fest
(define row-a (beside (tile C2) (tile C1) (tile C2) (tile C1) ));die zwei verschiedenen Reihen für das Spielfeld werden definiert
(define row-b (beside (tile C1) (tile C2) (tile C1) (tile C2) ))

(define (player a) (circle 10 "solid" a)); Funktion für die Spielfiguren. Über den Parameter a kann die Farbe der Figur eingestellt werden
(define P1 "red")
(define P2 "blue"); Abkürzung für die Farbe der Spielfiguren, P1 steht für "Player 1)
(define (move a x y z) (place-image/align (player a) x y "left" "top" z))
; Die Funktion move kann Spieler auf dem Spielfeld platzieren. Der Parameter a legt dabei die Farbe der Figur fest.
; x und y sind die Koordinaten der Figur, für z kann das Spielfeld oder auch eine weitere Figur eingesetzt werden.

(define CHESSBOARD (above row-a
                          row-b 
                          row-a
                          row-b)
)
; Das Spielfeld wird aufgebaut

(define EXAMPLE-GAME (move P1 40 0
                      (move P1 20 40
                       (move P2 60 60
                        CHESSBOARD)))
  )

;Es werden drei Spielfiguren auf dem Spielfeld platziert

; Aufgabe 1d) Für eine Änderung der Farbe der schwarzen Quadrate zu grau muss in meinem Code nur die Definition der Konstanten C1
; von "black" zu "gray" geändert werden. Dann sind alle vorher schwarzen Felder grau. Beim Code des Kollegen müsste diese Änderung
; für jedes einzelne Quadrat, also insg. 8 mal durchgeführt werden. Dazu kommt, dass die Änderungen mitten im Code wären, bei meinem
; Code wird die Farbe direkt am Anfang eingestellt. Außerdem habe ich mit einem Kommentar erklärt, was genau die betroffene Variable
; beschreibt. Dadurch liegt der Zeitaufwand bei meinem Code bei etwa 10 Sekunden, auch für jemanden, der den Code gar nicht kennt.
; Beim Code des Kollegen liegt er schätzungsweise bei 2 Minuten.


;AUFGABE 2

(define SNOW-COLOUR "white")

(define IMAGE-WIDTH 400) ; definiert die Breite des Bildes
(define HALF-IMAGE-WIDTH (* IMAGE-WIDTH 0.5)) ; Hälfte der Breite des Bildes
(define IMAGE-HEIGHT 600) ; definiert die Höhe des Bildes

(define 3XL 4.8)
(define XXL 3.8)
(define XL 2.6)
(define L 1.4)
(define M 1)
(define S 0.8)
(define XS 0.6)
(define XXS 0.2)

(define (make-position vertical) (make-posn HALF-IMAGE-WIDTH vertical)) ; ersetzt/verkürzt die strikte Funktion "make-posn" innerhalb der "place-images"-Fkt
(define (object-position SIZE FACTOR) (- IMAGE-HEIGHT (* SIZE FACTOR))) ; vereinfacht das Argument innerhalb der "make-position"-Fkt

(define (snowball RADIUS) (circle RADIUS "solid" SNOW-COLOUR)) ; erstellt eine weisse Kreisscheibe mit einstellbarem Radius (eine Schneekugel)
(define (hat HAT-COLOUR SIZE) (above (square (* SIZE M) "solid" HAT-COLOUR) (rectangle (* SIZE L) (* SIZE XXS) "solid" HAT-COLOUR))); Fkt für den Hut des Schneemans
(define (background BACKGROUND-COLOUR) (empty-scene IMAGE-WIDTH IMAGE-HEIGHT BACKGROUND-COLOUR)) ; Fkt für den Hintergund des Bildes

(define (SNOWMAN HAT-COLOUR BACKGROUND-COLOUR SIZE) ; Fkt, die die einzelnen Elemente zum echten Schneemann zusammenfügt
  (place-images
   (list (hat HAT-COLOUR SIZE)
         (snowball SIZE)
         (snowball (* SIZE S))
         (snowball (* SIZE XS))
         )
   (list (make-position (object-position SIZE 3XL))
         (make-position (object-position SIZE M))
         (make-position (object-position SIZE XL))
         (make-position (object-position SIZE XXL))
         )
   (background BACKGROUND-COLOUR)
   )
  )

(define (generate-image color1 color2 number) (SNOWMAN color1 color2 number))


